/*
        Terry Wu
*/
int _I2C_Error = 0;
int _I2C_Wait  = 1;
int  * BT880_I2CAddr;

int     I2C_WAIT = 1L;               // wait ?x15 microsecond
#define MAX_WAITREADY_RETRY     20

#define I2C_OUTPUT_DATA         0x01
#define I2C_OUTPUT_CLOCK        0x02
#define I2C_INPUT_DATA          0x01
#define I2C_INPUT_CLOCK         0x02

void wait15microsec(long count)
{
    int status0;
return; // No delay. Do as fast as CPU can
    if (count<=0) return;

    status0 = inp(0x61) & 0x10;
    while(status0 == (inp(0x61) & 0x10));
    while(count)
    {
        status0 = inp(0x61) & 0x10;
        while(status0 == (inp(0x61) & 0x10));
        count--;
    }
}

int _GetOutputRegister(void)
{
    int data;
    int * p = (int  *)BT880_I2CAddr;
    data = * p;
    wait15microsec(1);
    return data & 0xFF;
}

void _SetOutputRegister(int Data)
{
    int * p = (int  *)BT880_I2CAddr;
    *p = Data;
    wait15microsec(1);
}

int _GetInputRegister(void)
{
    int data;
    int * p = (int  *)BT880_I2CAddr;
    data = * p;
    wait15microsec(1);
    return data & 0xFF;
}

int _WaitReady(void)
{
    unsigned int TimeOut;
    int Count;

    _I2C_Error = 0;
    if (!_I2C_Wait) return 1;
    for (Count=0;Count<MAX_WAITREADY_RETRY;Count++)
    {
        if ((_GetInputRegister() & I2C_INPUT_CLOCK) == 0x00)
        {
            for (TimeOut=0x00FF;TimeOut!=0;TimeOut--)
            {
                if (_GetInputRegister() & I2C_INPUT_CLOCK)
                {
                    return 1;
                }
            }
            _I2C_Error = 1;
printf("\n ******* ERROR ******                                             \n"); // DEBUG
            return 0;
        }
    }

    return 1;
}

/*
        Export Functions
*/

void HWI2C_SetSCL(int flag)
{
    int data;

    data = _GetOutputRegister();

    if (flag)
        data |= I2C_OUTPUT_CLOCK;
    else
        data &= (~I2C_OUTPUT_CLOCK);

    _SetOutputRegister(data);
    wait15microsec(I2C_WAIT);

    if (flag) _WaitReady();
}

void HWI2C_SetSDA(int flag)
{
    int data;

    data = _GetOutputRegister();

    if (flag)
        data |= I2C_OUTPUT_DATA;
    else
        data &= (~I2C_OUTPUT_DATA);

    _SetOutputRegister(data);
    wait15microsec(I2C_WAIT);
}

int  HWI2C_GetSDA(void)
{
    int data;

    data = _GetInputRegister();
    wait15microsec(I2C_WAIT);

    if (data & I2C_INPUT_DATA)
        return 1;
    else
        return 0;
}

int  HWI2C_GetSCL(void)
{
    int data;

    data = _GetInputRegister();
    wait15microsec(I2C_WAIT);

    if (data & I2C_INPUT_CLOCK)
        return 1;
    else
        return 0;
}

int  HWI2C_IsErrorOccur(void)
{
    return _I2C_Error;
}

void HWI2C_Enable(void)
{
    int data;
    int * p = (int  *)BT880_I2CAddr;
    data = 0x03;
    *p = data;
    wait15microsec(1);
}

void HWI2C_Disable(void)
{
}

int HWI2C_Check(void)
{
    return 1;
}

