#include <dos.h>
#include <stdio.h>

/*

*/
#include "i2c.c"


void delay_nop(void)
{
        {
            int idx;
            for (idx=0;idx<2;idx++)
            {
                _asm nop
                _asm nop
                _asm nop
                _asm nop
                _asm nop
            }
        }
}
/*

*/
get_pci_busDeviceNo()
{
    union REGS r1;
    int   idx;

        r1.w.ax = 0xb102;
        r1.w.cx = 0x8802;
        r1.w.dx = 0x14F1;
        r1.w.si = 0;
        int386(0x1a, &r1, &r1);
        if (r1.w.ax & 0xff00)
        {
        }
        else return(r1.w.bx & 0xffff);

        r1.w.ax = 0xb102;
        r1.w.cx = 0x8801;
        r1.w.dx = 0x14F1;
        r1.w.si = 0;
        int386(0x1a, &r1, &r1);
        if (r1.w.ax & 0xff00)
        {
        }
        else return(r1.w.bx & 0xffff);

        r1.w.ax = 0xb102;
        r1.w.cx = 0x8811;
        r1.w.dx = 0x14F1; // Conexant
        r1.w.si = 0;
        int386(0x1a, &r1, &r1);

        if (r1.w.ax & 0xff00)
        {
        }
        else return(r1.w.bx & 0xffff);

        r1.w.ax = 0xb102;
        r1.w.cx = 0x8800; // CX23880
        r1.w.dx = 0x14F1; // Conexant
        r1.w.si = 0;
        int386(0x1a, &r1, &r1);

        if (r1.w.ax & 0xff00)
        {
        }
        else return(r1.w.bx & 0xffff);


    printf("CX2388X device not found.\n");
    return(-1);
}

PCI_write_config_word(short busDeviceNo, int reg, int value)
{
    union REGS r1;

    reg = reg*4;

    r1.w.ax = 0xb10c;
    r1.w.bx = busDeviceNo;
    r1.w.di = reg;
    r1.w.cx = value & 0xffff;
    int386(0x1a, &r1, &r1);
}

read_PCI_config_reg(short busDeviceNo,int reg)
{
    union REGS r1;
    unsigned config_reg;

    reg = reg*4;

    r1.w.ax = 0xb109;               // Read Config Word
    r1.w.bx = busDeviceNo;
    r1.w.di = reg;          // address lsw.
    int386(0x1a, &r1, &r1);

    if (r1.w.ax & 0xff00) {
        printf("Reading PCI config lsw failed\n");
        return(-1);
    }
    config_reg = r1.w.cx;
    r1.w.ax = 0xb109;               // Read Config Word
    r1.w.bx = busDeviceNo;
    r1.w.di = reg+2;                // address msw.
    int386(0x1a, &r1, &r1);

    if (r1.w.ax & 0xff00) {
        printf("Reading PCI config msw failed\n");
        return(-1);
    }
    config_reg = (r1.w.cx << 16) | (config_reg & 0xffff);
    return(config_reg);
}


/*


*/
#define DEVICE_EEPROM 0xA0

void* mmap(void* addr, int len, int prot, int flags, int fd, int off)
{
  union REGS r1;

  /* Map Physical Address */
  r1.w.ax = 0x0800;
  r1.w.bx = ((int)addr >> 16) & 0xFFFF;
  r1.w.cx = ((int)addr >>  0) & 0xFFF0;
  r1.w.si = (len >> 16) & 0xffff;
  r1.w.di = (len >>  0) & 0xffff;
  int386(0x31, &r1, &r1);
  if (r1.x.cflag)  {
    /* errno = EINVAL; */
    return((void*)-1);
    printf("mapping physical address failed\n");
  }
  addr = (void*)((r1.w.bx << 16) + r1.w.cx);
  return(addr);
}

mapBT880() {
    short busDeviceNo;
    void * BT880_BaseAddr;

    // Get PCI Bus number and device number.
    busDeviceNo = get_pci_busDeviceNo();
    if (busDeviceNo == -1) {
        return(-1);
    }

#if 0
    // Make sure NV PCI memory access enabled.
    PCI_write_config_word( busDeviceNo, 1,
        read_PCI_config_reg( busDeviceNo, 1 ) | 0x0002 // Memory Access Enabled.
            );
#endif

    // Get the PCI device memory map physical starting address. 16M size
    BT880_BaseAddr =
mmap((void*)read_PCI_config_reg(busDeviceNo,4),0x01000000,0,0,0,0);

    if (BT880_BaseAddr == (int *)-1)  {
        printf("Cannot mmmap(BT880)\n");
        return(-1);
    }
    BT880_I2CAddr = (int *)((long)BT880_BaseAddr+0x368000);
    return(0);
} /* end mapBT880 */

int main(int argc,char *argv[])
{
    int idx,Data,Status,found;

    if (mapBT880()==-1) return 1;

    found = 0;
    for (idx=0x0;idx<0xFF;idx+=2)
    {
        Data = 0xFF;
        Status = I2C_ReadByte(idx,(char *)&Data);
        if (Status)
        {
           printf("I2C Device %2.2Xh found (%2.2Xh).\n",idx,Data);
           found = 1;
        }
        else        printf("I2C Device %2.2Xh\015",idx);
    }
    printf("                                                 \015");
    if (!found)
    {
        printf("No I2C device found.\n");
        return 1;
    }
    return 0;
}
